/*
 * Copyright 2018 Confluent Inc.
 *
 * Licensed under the Confluent Community License (the "License"); you may not use
 * this file except in compliance with the License.  You may obtain a copy of the
 * License at
 *
 * http://www.confluent.io/confluent-community-license
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS, WITHOUT
 * WARRANTIES OF ANY KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations under the License.
 */

package io.confluent.ksql.analyzer;

public class AnalysisContext {

  public enum ParentType {
    SELECT("select"),
    SELECTITEM("selectitem"),
    INTO("into"),
    FROM("from"),
    WHERE("where"),
    GROUPBY("GROUPBY");

    private final String value;

    ParentType(final String value) {
      this.value = value;
    }

    public String getValue() {
      return value;
    }
  }

  private final ParentType parentType;

  public AnalysisContext() {
    this(null);
  }

  public AnalysisContext(final ParentType parentType) {
    this.parentType = parentType;
  }

  public ParentType getParentType() {
    return parentType;
  }

}
